"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var register_1 = require("./resolvers/password/register");
var impersonate_1 = require("./resolvers/impersonate");
var me_1 = require("./resolvers/me");
var user_1 = require("./resolvers/user");
var mutations_1 = require("./graphql/mutations");
var types_1 = require("./graphql/types");
var queries_1 = require("./graphql/queries");
var logout_1 = require("./resolvers/logout");
var merge = require("deepmerge");
var reset_1 = require("./resolvers/password/reset");
var refresh_access_token_1 = require("./resolvers/refresh-access-token");
var verify_email_1 = require("./resolvers/password/verify-email");
var service_authenticate_1 = require("./resolvers/service-authenticate");
exports.createJSAccountsGraphQL = function (Accounts, schemaOptions) {
    if (schemaOptions === void 0) { schemaOptions = {
        rootQueryName: 'Query',
        rootMutationName: 'Mutation',
        extend: true,
        withSchemaDefinition: false,
    }; }
    var schema = "\n  " + types_1.typeDefs + "\n\n  " + (schemaOptions.extend ? 'extend ' : '') + "type " + schemaOptions.rootQueryName + " {\n    " + queries_1.queries + "\n  }\n\n  " + (schemaOptions.extend ? 'extend ' : '') + "type " + schemaOptions.rootMutationName + " {\n    " + mutations_1.mutations + "\n  }\n\n  " + (schemaOptions.withSchemaDefinition ?
        "schema {\n    query: " + schemaOptions.rootMutationName + "\n    mutation: " + schemaOptions.rootQueryName + "\n  }" : '') + "\n  ";
    var resolvers = (_a = {
            User: user_1.User
        },
        _a[schemaOptions.rootMutationName] = {
            serviceAuthenticate: service_authenticate_1.serviceAuthenticate(Accounts),
            refreshTokens: refresh_access_token_1.refreshTokens(Accounts),
            logout: logout_1.logout(Accounts),
            impersonate: impersonate_1.impersonate(Accounts),
            registerPassword: register_1.registerPassword(Accounts),
            resetPassword: reset_1.resetPassword(Accounts),
            sendResetPasswordEmail: reset_1.sendResetPasswordEmail(Accounts),
            sendVerificationEmail: verify_email_1.sendVerificationEmail(Accounts),
            verifyEmail: verify_email_1.verifyEmail(Accounts)
        },
        _a[schemaOptions.rootQueryName] = {
            me: me_1.me(Accounts),
        },
        _a);
    return {
        schema: schema,
        extendWithResolvers: function (resolversObject) { return merge(resolvers, resolversObject); },
    };
    var _a;
};
//# sourceMappingURL=schema-builder.js.map