export declare const typeDefs = "\n  type AccountsError {\n      message: String!,\n      loginInfo: String,\n      errorCode: Int!,\n  }\n\n  type Tokens {\n    refreshToken: String\n    accessToken: String\n  }\n  \n  type LoginReturn {\n    sessionId: String\n    user: User\n    tokens: Tokens\n  }\n  \n  type ImpersonateReturn {\n    authorized: Boolean\n    tokens: Tokens\n    user: User\n  }\n\n  type User {\n    id: ID!\n    email: String\n    username: String\n  }\n\n\n  type GeneratedSecret {\n    ascii: String\n    hex: String\n    base32: String\n    qr_code_ascii: String\n    qr_code_hex: String\n    qr_code_base32: String\n    google_auth_qr: String\n    otpauth_url: String\n  }\n\n  input LoginUserIdentityType {\n    id: String\n    username: String\n    email: String\n  }\n\n  enum HashAlgorithm {\n    sha\n    sha1\n    sha224\n    sha256\n    sha384\n    sha512\n    md5\n    ripemd160\n  }\n\n  input PasswordLoginType {\n    user: LoginUserIdentityType\n    password: String\n    code: String\n  }\n  \n  input CreateUserInput {\n    username: String\n    email: String\n    password: String\n    profile: CreateUserProfileInput\n  }\n\n\n  \n\n  input PasswordInput {\n    digest: String\n    algorithm: String\n  }\n  \n  input CreateUserProfileInput {\n    name: String\n    firstName: String\n    lastName: String\n  }\n";
